summaryrefslogtreecommitdiffstats
path: root/cron-jobs/update-web-db
diff options
context:
space:
mode:
Diffstat (limited to 'cron-jobs/update-web-db')
-rwxr-xr-xcron-jobs/update-web-db47
1 files changed, 47 insertions, 0 deletions
diff --git a/cron-jobs/update-web-db b/cron-jobs/update-web-db
new file mode 100755
index 0000000..8631a04
--- /dev/null
+++ b/cron-jobs/update-web-db
@@ -0,0 +1,47 @@
+#!/bin/bash
+
+# run at nice 5. it can churn quite a bit of cpu after all.
+renice +5 -p $$ > /dev/null
+
+# setup paths
+SPATH="/srv/http/archweb"
+ARCHES="i686 x86_64"
+# having "more important repos" last should make [core] trickle to the top of
+# the updates list each hour rather than being overwhelmed by big [extra] and
+# [community] updates
+REPOS="community-testing multilib community extra testing core"
+LOGOUT="/tmp/archweb_update.log"
+
+# figure out what operation to perform
+cmd="$(basename $0)"
+if [[ $cmd != "update-web-db" && $cmd != "update-web-files-db" ]]; then
+ echo "Invalid command name '$cmd' specified!"
+ exit 1
+fi
+
+echo "$cmd: Updating DB at $(date)" >> "${LOGOUT}"
+
+## do the dirty, then output the result to a file.
+cd $SPATH
+for arch in ${ARCHES}; do
+ for repo in ${REPOS}; do
+ echo "Updating ${repo}-${arch}"
+ case "$cmd" in
+ update-web-db)
+ dbfile="/srv/ftp/${repo}/os/${arch}/${repo}.db.tar.gz"
+ flags="" ;;
+ update-web-files-db)
+ dbfile="/srv/ftp/${repo}/os/${arch}/${repo}.files.tar.gz"
+ flags="--filesonly" ;;
+ esac
+ ./manage.py reporead ${flags} ${arch} ${dbfile}
+ echo ""
+ done
+done >> "${LOGOUT}" 2>&1
+
+echo "" >> "${LOGOUT}"
+
+# rotate the file if it is getting big (> 10M), overwriting any old backup
+if [[ $(stat -c%s update-web-db) -gt 10485760 ]]; then
+ mv "${LOGOUT}" "${LOGOUT}.old"
+fi